package com.hzya.frame.u8.base.inventory.service.impl;

import cn.hutool.core.date.DateUtil;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.serviceUtil.ServiceUtil;
import com.hzya.frame.u8.base.identity.entity.UAIdentityEntity;
import com.hzya.frame.u8.base.identity.service.IUAIdentityService;
import com.hzya.frame.u8.base.inventory.dao.IInventoryDao;
import com.hzya.frame.u8.base.inventory.entity.BasPartEntity;
import com.hzya.frame.u8.base.inventory.entity.InventoryEntity;
import com.hzya.frame.u8.base.inventory.entity.InventorySubEntity;
import com.hzya.frame.u8.base.inventory.service.IBasPartService;
import com.hzya.frame.u8.base.inventory.service.IInventoryService;
import com.hzya.frame.u8.base.inventory.service.IInventorySubService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description
 * @Author xiangerlin
 * @Date 2025/3/13 15:39
 **/
@Service
public class InventoryService extends BaseService<InventoryEntity,String> implements IInventoryService {

    Logger logger = LogManager.getLogger(getClass());

    private IInventoryDao inventoryDao;

    @Autowired
    public void setInventoryDao(IInventoryDao dao) {
        this.inventoryDao = dao;
        this.dao = dao;
    }
    @Autowired
    private IInventorySubService subService;
    @Autowired
    private IBasPartService basPartService;
    @Autowired
    private IUAIdentityService uaIdentityService;
    /**
     * 查询存货档案
     *
     * @param entity
     * @return
     * @throws Exception
     */
    @DS("#entity.dataSourceCode")
    @Override
    public List<InventoryEntity> queryList(InventoryEntity entity) throws Exception {
        List<InventoryEntity> List = inventoryDao.query(entity);
        return List;
    }

    /**
     * 新增存货档案
     *
     * @param entity
     * @throws Exception
     */
    @DS("#entity.dataSourceCode")
    @Override
    public void saveInventory(InventoryEntity entity) throws Exception {
        //保存存货信息
        inventoryDao.save(entity);
        //保存子表数据
        InventorySubEntity subEntity = new InventorySubEntity();
        subEntity.setDataSourceCode(entity.getDataSourceCode());
        subEntity.setcInvSubCode(entity.getcInvCode());
        subEntity.setbInvKeyPart("0");//是否关键物料 1是0否
        subEntity.setAcc_name(entity.getAcc_name());
        subEntity.setPlanCheckDay("0");//计划检验天数
        subEntity.setdInvCreateDatetime(DateUtil.now());//建档日期
        subEntity.setiDrawType("0");//领料方式 0是直接领用，1是申请领用
        //检查子表有没有保存过
        List<InventorySubEntity> subEntityList = subService.query(subEntity);
        if (CollectionUtils.isEmpty(subEntityList)){
            subService.save(subEntity);
        }else {
            subService.update(subEntity);
        }
        //保存自定义表
        BasPartEntity part = new BasPartEntity();
        part.setInvCode(entity.getcInvCode());
        //先查一下有没有保存过
        List<BasPartEntity> partList = basPartService.query(part);
        if (CollectionUtils.isEmpty(partList)){
            //查最大流水号
            UAIdentityEntity uaidenIdentity =  uaIdentityService.queryMaxSaleOrderId("", "bas_part");
            if (null != uaidenIdentity){
                BasPartEntity basPartEntity = new BasPartEntity();
                basPartEntity.setInvCode(entity.getcInvCode());
                Integer id_num_add = uaidenIdentity.getiFatherId()+1;// +1
                long max_id = 1000000000 + id_num_add;//前面拼接上1000000000
                //更新最大编号
                uaidenIdentity.setCacc_id("002");
                uaidenIdentity.setcVouchType("bas_part");
                uaIdentityService.updateMaxSaleOrderId(uaidenIdentity);
            }
        }
    }

    /**
     * 修改存货档案
     *
     * @param entity
     * @throws Exception
     */
    @DS("#entity.dataSourceCode")
    @Override
    public void updateInventory(InventoryEntity entity) throws Exception {

    }
}
